#include "test_usart.h"
#include "global.h"

#define ADDR_USART_2 2
#define ADDR_USART_3 3
uint8_t addr_usart[8] = {0, ADDR_USART_2, ADDR_USART_3, };

static uint8_t tmp_buf[] = {1, 255, 0xaa, 0xbb, 0xcc, 255};
const uint8_t SIZE_BUF = sizeof(tmp_buf);    
const uint8_t ADR = 3;

void init_usart_1(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); //    USARTx

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOA, &GPIO_InitStruct);

    GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_USART1);
    GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_USART1);

    USART_InitStruct.USART_BaudRate = 9600;
    USART_InitStruct.USART_WordLength =  USART_WordLength_9b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(USART1, &USART_InitStruct);            
    
    USART_Cmd(USART1, ENABLE);
}

void init_usart_2(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE); //    USARTx

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOD, &GPIO_InitStruct);

    GPIO_PinAFConfig(GPIOD, GPIO_PinSource5, GPIO_AF_USART2);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource6, GPIO_AF_USART2);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_9b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd, _No)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(USART2, &USART_InitStruct);
    
    USART_SetAddress (USART2, ADDR_USART_2); // set address usart
    USART_WakeUpConfig (USART2, USART_WakeUp_AddressMark); // wakeup mode
    USART_ReceiverWakeUpCmd (USART2, ENABLE); // usart is mute
    
    USART_Cmd(USART2, ENABLE);      
}

void init_usart_3(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE); //    USARTx

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_11; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOB, &GPIO_InitStruct);

    GPIO_PinAFConfig(GPIOB, GPIO_PinSource10, GPIO_AF_USART3);
    GPIO_PinAFConfig(GPIOB, GPIO_PinSource11, GPIO_AF_USART3);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_9b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(USART3, &USART_InitStruct);    
    
    USART_SetAddress (USART3, ADDR_USART_3); // set address usart
    USART_WakeUpConfig (USART3, USART_WakeUp_AddressMark); // wakeup mode
    USART_ReceiverWakeUpCmd (USART3, ENABLE); // usart is mute
    
    USART_Cmd(USART3, ENABLE);        
}

void init_usart_4(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE); //    USARTx
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4, ENABLE); //  USARTx 

    GPIO_PinAFConfig(GPIOC, GPIO_PinSource10, GPIO_AF_UART4);
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource11, GPIO_AF_UART4);
        
    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_10 | GPIO_Pin_11; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_Init(GPIOC, &GPIO_InitStruct);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(UART4, &USART_InitStruct);
    
    USART_Cmd(UART4, ENABLE);    
}


void init_usart_5(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE); //    USARTx
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE); //    USARTx

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_12; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOC, &GPIO_InitStruct);

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_2; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOD, &GPIO_InitStruct);
    
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource12, GPIO_AF_UART5);
    GPIO_PinAFConfig(GPIOD, GPIO_PinSource2, GPIO_AF_UART5);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(UART5, &USART_InitStruct);
    
    USART_Cmd(UART5, ENABLE);
}


void init_usart_6(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART6, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE); //    USARTx
    

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOC, &GPIO_InitStruct);
    
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource6, GPIO_AF_USART6);
    GPIO_PinAFConfig(GPIOC, GPIO_PinSource7, GPIO_AF_USART6);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(USART6, &USART_InitStruct);
    
    USART_Cmd(USART6, ENABLE);
}

void init_usart_7(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART7, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOE, ENABLE); //    USARTx
    

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_7; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOE, &GPIO_InitStruct);
    
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource8, GPIO_AF_UART7);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource7, GPIO_AF_UART7);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(UART7, &USART_InitStruct);
    
    USART_Cmd(UART7, ENABLE);
}

void init_usart_8(void)
{
    GPIO_InitTypeDef GPIO_InitStruct;
    USART_InitTypeDef USART_InitStruct;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART8, ENABLE); //  USARTx 
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOE, ENABLE); //    USARTx
    

    GPIO_InitStruct.GPIO_Pin = GPIO_Pin_1 | GPIO_Pin_0; //(  USART)
    GPIO_InitStruct.GPIO_Mode = GPIO_Mode_AF; //(AF -   )
    GPIO_InitStruct.GPIO_Speed = GPIO_Speed_25MHz; //(max   )
    GPIO_InitStruct.GPIO_OType = GPIO_OType_PP; //(_PP - push/pull output, _OD - open drain output)
    GPIO_InitStruct.GPIO_PuPd = GPIO_PuPd_NOPULL;
    GPIO_Init(GPIOE, &GPIO_InitStruct);
    
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource1, GPIO_AF_UART8);
    GPIO_PinAFConfig(GPIOE, GPIO_PinSource0, GPIO_AF_UART8);

    USART_InitStruct.USART_BaudRate = 9600; 
    USART_InitStruct.USART_WordLength =  USART_WordLength_8b; //(_9b)
    USART_InitStruct.USART_StopBits = USART_StopBits_1; //(_0_5, _2, _1_5)
    USART_InitStruct.USART_Parity = USART_Parity_No; //(_Even, _Odd)
    USART_InitStruct.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; 
    USART_InitStruct.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //(_RTS, _CTS, _RTS_CTS)
    USART_Init(UART8, &USART_InitStruct);
    
    USART_Cmd(UART8, ENABLE);
}

//    usart
void usart_1_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

//    usart
void usart_2_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

//    usart
void usart_3_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(USART3, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

//    usart
void usart_4_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_5_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_6_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART6_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(USART6, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_7_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = UART7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(UART7, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_8_nvic(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;

    /* Configure the NVIC Preemption Priority Bits */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);

    /* Enable the USART2 Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = UART8_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;

    NVIC_Init(&NVIC_InitStructure);

    //       
    USART_ITConfig(UART8, USART_IT_RXNE, ENABLE);
    //USART_ITConfig(USART1, USART_IT_TXE, ENABLE);   
}

void usart_rec(uint8_t n_usart)
{            
    switch(n_usart)
    {
        case 1:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(USART1);        
        break;
        
        case 2:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(USART2);        
            i_buf_rec[n_usart - 1]++;
        break;
        
        case 3:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(USART3);        
            i_buf_rec[n_usart - 1]++;
        break;
        
        case 4:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(UART4);        
        break;
        
        case 5:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(UART5);        
        break;
        
        case 6:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(USART6);        
        break;
        
        case 7:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(UART7);        
        break;
        
        case 8:
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = USART_ReceiveData(UART8);        
        break;
    }        
}

void usart_trans(uint8_t n_usart)
{
    static uint8_t i_tmp_buf = 0;
    
    uint16_t adr_data;    
    static uint8_t f_adr_send = 0;    
    
    switch (n_usart)
    {
        case 1:     
            //     
            if(f_adr_send == 0)
            {
                //  
                adr_data = ADR | 0x0100;
                USART_SendData(USART1, adr_data);
                f_adr_send = 1;
            }
            else
            {
                //  
                USART_SendData(USART1, tmp_buf[i_tmp_buf]);
                
                i_tmp_buf++;
                if(i_tmp_buf == SIZE_BUF)
                {
                    i_tmp_buf = 0;
                    USART_ITConfig(USART1, USART_IT_TXE, DISABLE);
                }               
            }
        break;
        
        case 2:            
            USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
        break;
        
        case 3:            
            USART_ITConfig(USART3, USART_IT_TXE, DISABLE);
        break;                       
    }        
}


void rec_9_bit_mode_slave(uint16_t input_data, uint8_t n_usart)
{   
    uint8_t adr_data = 0;
    uint8_t f_adr_input = 0;
    static uint8_t f_adr_rec_mode[8] = {0,}; //   usart    
    
    //   
    if( (input_data & 0x0100) != 0 )
    {
        // 9 bit set -> address
        f_adr_input = 1;
    }

    //  
    if(f_adr_input == 1)
    {
        //   
        adr_data = (input_data & 0x00FF);
        
        //    ->     
        if(adr_data == addr_usart[n_usart - 1])
        {
            f_adr_rec_mode[n_usart - 1] = 1;
        }
        else
        {
            f_adr_rec_mode[n_usart - 1] = 0;
        }            
    }
    //   -     
    //         -  
    else
    {
        //      
        //   
        //    -  
        if(f_adr_rec_mode[n_usart - 1] == 1)
        {
            buf_rec[n_usart - 1][ i_buf_rec[n_usart - 1] ] = (input_data & 0x00FF);
            i_buf_rec[n_usart - 1]++;
            if(i_buf_rec[n_usart - 1] == S_BUF)
            {
                i_buf_rec[n_usart - 1] = 0;
            }
        }        
    }                                       
}
    
